# import charms.reactive.flags as flags
import charms.reactive as reactive
import socket

from charmhelpers.contrib.templating.contexts import dict_keys_without_hyphens


class ControllerHA(reactive.Endpoint):

    @reactive.when('endpoint.{endpoint_name}.joined')
    def provide_peer_data(self, config, hostname=socket.gethostname()):
        # technically, there is only one peer relation but we have a list
        for rel in self.relations:
            rel.to_publish['hostname'] = hostname

    @property
    def peer_data(self):
        peer_data = {}
        if self.relations:
            # only one peer relation is ever present for a given endpoint
            rel = self.relations[0]
            # only one HA peer is expected
            assert len(rel.joined_units) < 2
            peer_data = dict_keys_without_hyphens(
                rel.joined_units[0].received)
        return peer_data
